Merge branch 'jc/stash-create'
[git/git.git] / git-stash.sh
CommitLineData
f2c66ed1
NS
1#!/bin/sh
2# Copyright (c) 2007, Nanako Shiraishi
3
4USAGE='[ | list | show | apply | clear]'
5
3cd2491a 6SUBDIRECTORY_OK=Yes
f2c66ed1
NS
7. git-sh-setup
8require_work_tree
ceff079b 9cd_to_toplevel
f2c66ed1
NS
10
11TMP="$GIT_DIR/.git-stash.$$"
12trap 'rm -f "$TMP-*"' 0
13
14ref_stash=refs/stash
15
16no_changes () {
5be60078
JH
17 git diff-index --quiet --cached HEAD &&
18 git diff-files --quiet
f2c66ed1
NS
19}
20
21clear_stash () {
7ab3cc70
JH
22 if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
23 then
a9ee9bf9 24 git update-ref -d $ref_stash $current
7ab3cc70 25 fi
f2c66ed1
NS
26}
27
bc9e7399 28create_stash () {
9f62e18a
JH
29 stash_msg="$1"
30
f2c66ed1
NS
31 if no_changes
32 then
f2c66ed1
NS
33 exit 0
34 fi
f12e925a 35
f2c66ed1 36 # state of the base commit
5be60078 37 if b_commit=$(git rev-parse --verify HEAD)
f2c66ed1 38 then
5be60078 39 head=$(git log --abbrev-commit --pretty=oneline -n 1 HEAD)
f2c66ed1
NS
40 else
41 die "You do not have the initial commit yet"
42 fi
43
5be60078 44 if branch=$(git symbolic-ref -q HEAD)
f2c66ed1
NS
45 then
46 branch=${branch#refs/heads/}
47 else
48 branch='(no branch)'
49 fi
50 msg=$(printf '%s: %s' "$branch" "$head")
51
52 # state of the index
5be60078 53 i_tree=$(git write-tree) &&
6143fa2c 54 i_commit=$(printf 'index on %s\n' "$msg" |
5be60078 55 git commit-tree $i_tree -p $b_commit) ||
f2c66ed1
NS
56 die "Cannot save the current index state"
57
58 # state of the working tree
59 w_tree=$( (
b24f56d6
JH
60 rm -f "$TMP-index" &&
61 cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
f2c66ed1
NS
62 GIT_INDEX_FILE="$TMP-index" &&
63 export GIT_INDEX_FILE &&
b24f56d6 64 git read-tree -m $i_tree &&
5be60078
JH
65 git add -u &&
66 git write-tree &&
f2c66ed1
NS
67 rm -f "$TMP-index"
68 ) ) ||
69 die "Cannot save the current worktree state"
70
71 # create the stash
9f62e18a
JH
72 if test -z "$stash_msg"
73 then
74 stash_msg=$(printf 'WIP on %s' "$msg")
75 else
76 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
77 fi
78 w_commit=$(printf '%s\n' "$stash_msg" |
5be60078 79 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
f2c66ed1 80 die "Cannot record working tree state"
bc9e7399 81}
f2c66ed1 82
bc9e7399
JH
83save_stash () {
84 stash_msg="$1"
85
86 if no_changes
87 then
88 echo >&2 'No local changes to save'
89 exit 0
90 fi
91 test -f "$GIT_DIR/logs/$ref_stash" ||
92 clear_stash || die "Cannot initialize stash"
93
94 create_stash "$stash_msg"
a9ee9bf9
EM
95
96 # Make sure the reflog for stash is kept.
97 : >>"$GIT_DIR/logs/$ref_stash"
f2c66ed1 98
9f62e18a 99 git update-ref -m "$stash_msg" $ref_stash $w_commit ||
f2c66ed1 100 die "Cannot save the current status"
9f62e18a 101 printf >&2 'Saved "%s"\n' "$stash_msg"
f2c66ed1
NS
102}
103
401de405 104have_stash () {
5be60078 105 git rev-parse --verify $ref_stash >/dev/null 2>&1
401de405
JK
106}
107
f2c66ed1 108list_stash () {
401de405 109 have_stash || return 0
5be60078 110 git log --pretty=oneline -g "$@" $ref_stash |
f2c66ed1
NS
111 sed -n -e 's/^[.0-9a-f]* refs\///p'
112}
113
114show_stash () {
5be60078 115 flags=$(git rev-parse --no-revs --flags "$@")
f2c66ed1
NS
116 if test -z "$flags"
117 then
118 flags=--stat
119 fi
5be60078 120 s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@")
f2c66ed1 121
5be60078
JH
122 w_commit=$(git rev-parse --verify "$s") &&
123 b_commit=$(git rev-parse --verify "$s^") &&
e7187e4e 124 git diff $flags $b_commit $w_commit
f2c66ed1
NS
125}
126
127apply_stash () {
5be60078 128 git diff-files --quiet ||
f2c66ed1
NS
129 die 'Cannot restore on top of a dirty state'
130
150937c4
JS
131 unstash_index=
132 case "$1" in
133 --index)
134 unstash_index=t
135 shift
136 esac
137
f2c66ed1 138 # current index state
5be60078 139 c_tree=$(git write-tree) ||
f2c66ed1
NS
140 die 'Cannot apply a stash in the middle of a merge'
141
cbeaccc3
JH
142 # stash records the work tree, and is a merge between the
143 # base commit (first parent) and the index tree (second parent).
5be60078
JH
144 s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@") &&
145 w_tree=$(git rev-parse --verify "$s:") &&
cbeaccc3
JH
146 b_tree=$(git rev-parse --verify "$s^1:") &&
147 i_tree=$(git rev-parse --verify "$s^2:") ||
f2c66ed1
NS
148 die "$*: no valid stashed state found"
149
cbeaccc3
JH
150 unstashed_index_tree=
151 if test -n "$unstash_index" && test "$b_tree" != "$i_tree"
152 then
89d750bf 153 git diff-tree --binary $s^2^..$s^2 | git apply --cached
150937c4
JS
154 test $? -ne 0 &&
155 die 'Conflicts in index. Try without --index.'
156 unstashed_index_tree=$(git-write-tree) ||
157 die 'Could not save index tree'
158 git reset
cbeaccc3 159 fi
150937c4 160
f2c66ed1
NS
161 eval "
162 GITHEAD_$w_tree='Stashed changes' &&
163 GITHEAD_$c_tree='Updated upstream' &&
164 GITHEAD_$b_tree='Version stash was based on' &&
165 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
166 "
167
168 if git-merge-recursive $b_tree -- $c_tree $w_tree
169 then
170 # No conflict
cbeaccc3
JH
171 if test -n "$unstashed_index_tree"
172 then
173 git read-tree "$unstashed_index_tree"
83b3df7d
JH
174 else
175 a="$TMP-added" &&
89d750bf 176 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
83b3df7d
JH
177 git read-tree --reset $c_tree &&
178 git update-index --add --stdin <"$a" ||
179 die "Cannot unstage modified files"
180 rm -f "$a"
cbeaccc3
JH
181 fi
182 git status || :
f2c66ed1
NS
183 else
184 # Merge conflict; keep the exit status from merge-recursive
150937c4 185 status=$?
cbeaccc3
JH
186 if test -n "$unstash_index"
187 then
188 echo >&2 'Index was not unstashed.'
189 fi
150937c4 190 exit $status
f2c66ed1
NS
191 fi
192}
193
194# Main command set
195case "$1" in
fcb10a96
JH
196list)
197 shift
f2c66ed1
NS
198 if test $# = 0
199 then
200 set x -n 10
201 shift
202 fi
203 list_stash "$@"
204 ;;
205show)
206 shift
207 show_stash "$@"
208 ;;
209apply)
210 shift
211 apply_stash "$@"
212 ;;
213clear)
214 clear_stash
215 ;;
bc9e7399
JH
216create)
217 if test $# -gt 0 && test "$1" = create
218 then
219 shift
220 fi
221 create_stash "$*" && echo "$w_commit"
222 ;;
9f62e18a
JH
223help | usage)
224 usage
f2c66ed1
NS
225 ;;
226*)
9f62e18a
JH
227 if test $# -gt 0 && test "$1" = save
228 then
229 shift
230 fi
231 save_stash "$*" && git-reset --hard
232 ;;
f2c66ed1 233esac